#ifndef __NLL_CONFIG_H_INCLUDED__
#define __NLL_CONFIG_H_INCLUDED__

#ifdef USE_FLOATING_POINT
#define NLL_FLOATING_POINT
#endif

#ifdef USE_SYSTEM_FUNCTION
#define NLL_SYSTEM_FUNCTION
#endif
#ifdef USE_SYSCALL_FUNCTION
#define NLL_SYSCALL_FUNCTION
#endif
#ifdef USE_NETWORK_FUNCTION
#define NLL_NETWORK_FUNCTION
#endif

/* #define NLL_MEMORY_STATIC */

#define NLL_MULTIBYTE_NAME
#define NLL_LABEL_ARGUMENTS
/* #define NLL_STDIO_FUNCTION */
#define NLL_TYPECHANGE_ENABLE
#define NLL_COMMAND_NEED_SPACE
/* #define NLL_FORMULA_NO_FIXED */

/* #define NLL_TERM_DISABLE */

/* #define NLL_INTERNAL_EXEC_DISABLE */

/* #define NLL_EXTEND_FUNCTION */

#ifdef WIN32
#define NLL_OUTPUT_NOWAIT
#endif

#if defined(USE_SDL1) || defined(USE_SDL2)
#define USE_SDL
#endif
#ifdef USE_SDL2
#define USE_SDL_RENDERER
#endif

#define LINE_MAXLEN 256
#define LINE_MAXNUM 1024

#define SYMBOL_NAMELEN 32

#define LABEL_NAMELEN SYMBOL_NAMELEN
#define LABEL_MAXNUM 256

#define VARIABLE_NAMELEN SYMBOL_NAMELEN
#define VARIABLE_MAXNUM 256

#define VALUE_MAXNUM 4096

#ifdef NLL_MEMORY_STATIC
#define STRING_MAXLEN 256
#else
#define STRING_MAXLEN 65536
#endif
#define STRING_MAXNUM 256

#define ELEMENT_MAXNUM 1024

#define COMMAND_MAXNUM 1024
#define COMMAND_ARG_MAXNUM 4
#define COMMAND_ARG_WORD_MAXLEN 16

#define POSITION_MAXNUM 64

#define ARRAY_MAXNUM 1024

#define AREA_SIZE 4096

#define STACK_MAXNUM 256

#define FILEID_MAXNUM 256
#define QUEUEID_MAXNUM 64

#define FRAMEBUF_MAXWIDTH       120
#define FRAMEBUF_MAXHEIGHT       60
#define FRAMEBUF_DEFAULT_WIDTH   40
#define FRAMEBUF_DEFAULT_HEIGHT  25

#define GRAPHIC_MAXWIDTH       4096
#define GRAPHIC_MAXHEIGHT      4096
#define GRAPHIC_DEFAULT_WIDTH   640
#define GRAPHIC_DEFAULT_HEIGHT  480

#define GRAPHIC_IMAGE_MAXNUM 1024

/* #define AUDIO_AVERAGING_AMP_LEVEL */
#define AUDIO_PER_NUM 1024
#define AUDIO_DEFAULT_SAMPLING_FREQ 44100
#define AUDIO_UNIT_OUTMAX 8
#define AUDIO_UNIT_ENVMAX 16
#define AUDIO_UNIT_FILFWMAX 16
#define AUDIO_UNIT_FILBWMAX 16
#define AUDIO_UNIT_BUFNUM AUDIO_UNIT_FILFWMAX /* Max of FILFWMAX and FILBWMAX */
#define AUDIO_UNITSET_MAXNUM 64

#endif
